Index: moodle/lib/javascript-static.js
--- moodle/lib/javascript-static.js Base (1.88)
+++ moodle/lib/javascript-static.js Locally Modified (Based On 1.88)
@@ -721,19 +721,46 @@
             fn();
     }
 }
-
-function getElementsByClassName(oElm, strTagName, oClassNames) {
+/**
+ * Replacement for getElementsByClassName in browsers that aren't cool enough
+ * 
+ * Relying on the built-in getElementsByClassName is far, far faster than
+ * using YUI.
+ * 
+ * Note: the third argument used to be an object with odd behaviour. It now
+ * acts like the 'name' in the HTML5 spec, though the old behaviour is still
+ * mimicked if you pass an object.
+ *
+ * @param {Node} oElm The top-level node for searching. To search a whole
+ *                    document, use `document`.
+ * @param {String} strTagName filter by tag names
+ * @param {String} name same as HTML5 spec
+ */
+function getElementsByClassName(oElm, strTagName, name) {
+    // for backwards compatibility
+    if(typeof name == "object") {
+        var names = new Array();
+        for(var i=0; i<name.length; i++) names.push(names[i]);
+        name = names.join('');
+    }
+    // use native implementation if possible
+    if (oElm.getElementsByClassName && Array.filter) {
+        if (strTagName == '*') {
+            return oElm.getElementsByClassName(name);
+        } else {
+            return Array.filter(oElm.getElementsByClassName(name), function(el) {
+                return el.nodeName.toLowerCase() == strTagName.toLowerCase();
+            });
+        }
+    }
+    // native implementation unavailable, fall back to slow method
     var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
     var arrReturnElements = new Array();
     var arrRegExpClassNames = new Array();
-    if(typeof oClassNames == "object") {
-        for(var i=0; i<oClassNames.length; i++) {
-            arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames[i].replace(/\-/g, "\\-") + "(\\s|$)"));
+    var names = name.split(' ');
+    for(var i=0; i<names.length; i++) {
+        arrRegExpClassNames.push(new RegExp("(^|\\s)" + names[i].replace(/\-/g, "\\-") + "(\\s|$)"));
         }
-    }
-    else{
-        arrRegExpClassNames.push(new RegExp("(^|\\s)" + oClassNames.replace(/\-/g, "\\-") + "(\\s|$)"));
-    }
     var oElement;
     var bMatchesAll;
     for(var j=0; j<arrElements.length; j++) {
Index: moodle/lib/outputrenderers.php
--- moodle/lib/outputrenderers.php Base (1.14)
+++ moodle/lib/outputrenderers.php Locally Modified (Based On 1.14)
@@ -495,21 +495,21 @@
         $this->page->requires->js('lib/overlib/overlib.js')->in_head();
         $this->page->requires->js('lib/overlib/overlib_cssstyle.js')->in_head();
         $this->page->requires->js('lib/cookies.js')->in_head();
-        $this->page->requires->js_function_call('setTimeout', Array('fix_column_widths()', 20));
+        $this->page->requires->js_function_call('setTimeout', array('fix_column_widths()', 20));
 
         $focus = $this->page->focuscontrol;
         if (!empty($focus)) {
             if (preg_match("#forms\['([a-zA-Z0-9]+)'\].elements\['([a-zA-Z0-9]+)'\]#", $focus, $matches)) {
                 // This is a horrifically bad way to handle focus but it is passed in
                 // through messy formslib::moodleform
-                $this->page->requires->js_function_call('old_onload_focus', Array($matches[1], $matches[2]));
+                $this->page->requires->js_function_call('old_onload_focus', array($matches[1], $matches[2]));
             } else if (strpos($focus, '.')!==false) {
                 // Old style of focus, bad way to do it
                 debugging('This code is using the old style focus event, Please update this code to focus on an element id or the moodleform focus method.', DEBUG_DEVELOPER);
                 $this->page->requires->js_function_call('old_onload_focus', explode('.', $focus, 2));
             } else {
                 // Focus element with given id
-                $this->page->requires->js_function_call('focuscontrol', Array($focus));
+                $this->page->requires->js_function_call('focuscontrol', array($focus));
             }
         }
 
@@ -691,7 +691,7 @@
      *      removed when there is a $PAGE->... replacement.
      * @return string HTML that you must output this, preferably immediately.
      */
-    public function header($navigation = '', $menu='') {
+    public function header($menu='') {
         // TODO remove $navigation and $menu arguments - replace with $PAGE->navigation
         global $USER, $CFG;
 
@@ -701,10 +701,10 @@
         $templatefile = $this->page->theme->template_for_page($this->page->generaltype);
         if ($templatefile) {
             // Render the template.
-            $template = $this->render_page_template($templatefile, $menu, $navigation);
+            $template = $this->render_page_template($templatefile, $menu);
         } else {
             // New style template not found, fall back to using header.html and footer.html.
-            $template = $this->handle_legacy_theme($navigation, $menu);
+            $template = $this->handle_legacy_theme($menu);
         }
 
         // Slice the template output into header and footer.
@@ -734,7 +734,7 @@
      * @param array $navigation The navigation that will be used in the included file
      * @return string HTML code
      */
-    protected function render_page_template($templatefile, $menu, $navigation) {
+    protected function render_page_template($templatefile, $menu) {
         global $CFG, $SITE, $THEME, $USER;
         // The next lines are a bit tricky. The point is, here we are in a method
         // of a renderer class, and this object may, or may not, be the same as
@@ -746,6 +746,9 @@
         $PAGE = $this->page;
         $COURSE = $this->page->course;
 
+        // Required for legacy template uses
+        $navigation = $this->has_navbar();
+
         ob_start();
         include($templatefile);
         $template = ob_get_contents();
@@ -759,12 +762,13 @@
      * @param array $menu The menu that will be used in the included file
      * @return string HTML code
      */
-    protected function handle_legacy_theme($navigation, $menu) {
+    protected function handle_legacy_theme($menu) {
         global $CFG, $SITE, $USER;
         // Set a pretend global from the properties of this class.
         // See the comment in render_page_template for a fuller explanation.
         $COURSE = $this->page->course;
         $THEME = $this->page->theme;
+        $OUTPUT = $this;
 
         // Set up local variables that header.html expects.
         $direction = $this->htmlattributes();
@@ -789,6 +793,7 @@
         $course = $this->page->course;
         $performanceinfo = self::PERFORMANCE_INFO_TOKEN;
 
+        $navigation = $this->has_navbar();
         if (!$menu && $navigation) {
             $menu = $loggedinas;
         }
@@ -2250,9 +2255,87 @@
     public function container_end() {
         return $this->opencontainers->pop('container');
     }
+
+   /**
+     * Make nested HTML lists out of the items
+     *
+     * The resulting list will look something like this:
+     *
+     * <pre>
+     * <<ul>>
+     * <<li>><div class='tree_item parent'>(item contents)</div>
+     *      <<ul>
+     *      <<li>><div class='tree_item'>(item contents)</div><</li>>
+     *      <</ul>>
+     * <</li>>
+     * <</ul>>
+     * </pre>
+     *
+     * @param array[]tree_item $items
+     * @param array[string]string $attrs html attributes passed to the top of
+     * the list
+     * @return string HTML
+     */
+    function tree_block_contents($items, $attrs=array()) {
+        // exit if empty, we don't want an empty ul element
+        if (empty($items)) {
+            return '';
 }
+        // array of nested li elements
+        $lis = array();
+        foreach ($items as $item) {
+            // this applies to the li item which contains all child lists too
+            $content = $item->content($this);
+            $liclasses = array($item->get_css_type());
+            if (!$item->forceopen || (!$item->forceopen && $item->collapse) || (count($item->children)==0  && $item->nodetype==navigation_node::NODETYPE_BRANCH)) {
+                $liclasses[] = 'collapsed';
+            }
+            if ($item->isactive === true) {
+                $liclasses[] = 'current_branch';
+            }
+            $liattr = array('class'=>join(' ',$liclasses));
+            // class attribute on the div item which only contains the item content
+            $divclasses = array('tree_item');
+            if (!empty($item->children)  || $item->nodetype==navigation_node::NODETYPE_BRANCH) {
+                $divclasses[] = 'branch';
+            } else {
+                $divclasses[] = 'leaf';
+            }
+            if (!empty($item->classes) && count($item->classes)>0) {
+                $divclasses[] = join(' ', $item->classes);
+            }
+            $divattr = array('class'=>join(' ', $divclasses));
+            if (!empty($item->id)) {
+                $divattr['id'] = $item->id;
+            }
+            $content = $this->output_tag('p', $divattr, $content) . $this->tree_block_contents($item->children);
+            if (!empty($item->preceedwithhr) && $item->preceedwithhr===true) {
+                $content = $this->output_tag('hr', array(), null).$content;
+            }
+            $content = $this->output_tag('li', $liattr, $content);
+            $lis[] = $content;
+        }
+        return $this->output_tag('ul', $attrs, implode("\n", $lis));
+    }
 
+    /**
+     * Return the navbar content so that it can be echoed out by the layout
+     * @return string XHTML navbar
+     */
+    public function navbar() {
+        return $this->page->navbar->content();
+    }
 
+    /**
+     * Checks to see if there are any items on the navbar object
+     * @return bool true if there are, false if not
+     */
+    public function has_navbar() {
+        return $this->page->navbar->has_items();
+    }
+}
+
+
 /// RENDERERS
 
 /**
Index: moodle/lib/pagelib.php
--- moodle/lib/pagelib.php Base (1.146)
+++ moodle/lib/pagelib.php Locally Modified (Based On 1.146)
@@ -126,6 +126,12 @@
     protected $_button = '';
 
     protected $_theme = null;
+    /** @var null|global_navigation Contains the global navigation structure*/
+    protected $_navigation = null;
+    /** @var null|settings_navigation Contains the settings navigation structure*/
+    protected $_settingsnav = null;
+    /** @var null|navbar Contains the navbar structure*/
+    protected $_navbar = null;
 
     /**
      * Then the theme is initialsed, we save the stack trace, for use in error messages.
@@ -438,6 +444,40 @@
     }
 
     /**
+     * Return the navigation object
+     * @return global_navigation
+     */
+    public function get_navigation() {
+        if ($this->_navigation === null) {
+            $this->_navigation = new global_navigation();
+        }
+        return $this->_navigation;
+    }
+
+    /**
+     * Return a navbar object
+     * @return navbar
+     */
+    public function get_navbar() {
+        if ($this->_navbar === null) {
+            $this->_navbar = new navbar($this);
+        }
+        return $this->_navbar;
+    }
+
+    /**
+     * Returns the settings navigation object
+     * @return settings_navigation
+     */
+    public function get_settingsnav() {
+        if ($this->_settingsnav === null) {
+            $this->_settingsnav = new settings_navigation($this);
+            $this->_settingsnav->initialise();
+        }
+        return $this->_settingsnav;
+    }
+
+    /**
      * PHP overloading magic to make the $PAGE->course syntax work by redirecting
      * it to the corresponding $PAGE->get_course() method if there is one, and
      * throwing an exception if not.
Index: moodle/lib/setup.php
--- moodle/lib/setup.php Base (1.285)
+++ moodle/lib/setup.php Locally Modified (Based On 1.285)
@@ -241,6 +241,7 @@
     require_once($CFG->libdir .'/ajax/ajaxlib.php');    // Functions for managing our use of JavaScript and YUI
     require_once($CFG->libdir .'/weblib.php');          // Functions relating to HTTP and content
     require_once($CFG->libdir .'/outputlib.php');       // Functions for generating output
+    require_once($CFG->libdir .'/navigationlib.php');   // Class for generating Navigation structure
     require_once($CFG->libdir .'/dmllib.php');          // Database access
     require_once($CFG->libdir .'/datalib.php');         // Legacy lib with a big-mix of functions.
     require_once($CFG->libdir .'/accesslib.php');       // Access control functions
